#ifndef EFL_PART_EO_HH
#define EFL_PART_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_part.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "eo_base.eo.hh"
namespace efl { 
struct Part;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Part> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct Part {
   ::efl::eolian::return_traits< ::eo::Base>::type part( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_PART_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Part() const;
   operator ::efl::Part&();
   operator ::efl::Part const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Part> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Part const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Part : ::efl::eo::concrete
{
   explicit Part( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Part(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Part(Part const& other) = default;
   Part(Part&& other) = default;
   Part& operator=(Part const& other) = default;
   Part& operator=(Part&& other) = default;
   Part()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Part( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Part(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::eo::Base>::type part( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_PART_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Part> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Part const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Part) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Part>::value, "");
} 
#include "efl_part.eo.impl.hh"
#endif
